Index: flexpart_code/fpmetbinary_mod.F90
===================================================================
--- flexpart_code/fpmetbinary_mod.F90	(revision 64c820a29518db4158976feda349b1e551dec5c9)
+++ flexpart_code/fpmetbinary_mod.F90	(revision b6b9db0ffbc6a01864e847461061a3bb2f9680bc)
@@ -44,5 +44,8 @@
     USE com_mod
     USE conv_mod
-    USE par_mod, ONLY : nxmax, nymax, nzmax, nuvzmax, nwzmax
+    USE par_mod, ONLY : nxmax, nymax, nzmax, nuvzmax, nwzmax, numclass, maxspec, &
+&                       maxnests, nxmaxn, nymaxn
+
+    USE netcdf
 
     IMPLICIT NONE
@@ -52,9 +55,17 @@
     INTEGER, PARAMETER :: IOUNIT_DUMP = 33, IOUNIT_LOAD = 34, &
                           IOUNIT_TEXTOUT = 35
+                          
+                   
+    INTEGER, PARAMETER :: PREPROC_FMT_STR_DIM = 11
 
     ! When a change is made to the format of the preprocessed file, such that
     ! this routine will not be able to read a previous version, this version
     ! string should be modified
-    CHARACTER(LEN=12), PARAMETER :: PREPROC_FORMAT_VERSION_STR = 'FP_p-9.3.1'//char(0)
+
+
+    ! WARNING - for now, for NC4 compatability, make sure that the PREPROC_FMT_STR_DIM 
+    ! defined above is exactly the length of the string PLUS the null character added
+    ! I've had a hell of a time making it all compatible with NC4 (DJM)
+    CHARACTER(LEN=PREPROC_FMT_STR_DIM), PARAMETER :: PREPROC_FORMAT_VERSION_STR = 'FP_p-9.3.2'//char(0)
 
     PRIVATE IOUNIT_DUMP, IOUNIT_LOAD, IOUNIT_TEXTOUT, fpio,    &
@@ -90,8 +101,21 @@
         INTEGER millisecs_start, millisecs_stop, count_rate, count_max
 
+        INTEGER :: ncretval, ncid          ! NetCDF func return value, file id
+
         CALL SYSTEM_CLOCK(millisecs_start, count_rate, count_max)
-        OPEN(IOUNIT_DUMP, file=filename, action='WRITE', status='REPLACE', form="unformatted", access="stream")
-        CALL fpio(IOUNIT_DUMP, 'DUMP', cm_index)
-        CLOSE(IOUNIT_DUMP)
+
+        ! Create and open NC4 file for writing
+        PRINT *, 'Opening NC4 file...'
+        ncretval = nf90_create(filename, &
+&                              OR(NF90_CLOBBER, NF90_HDF5), &
+&                              ncid)
+
+
+
+        CALL fpio(ncid, 'DUMP', cm_index)
+
+        PRINT *, 'Closing NC4 file...'
+        ncretval = nf90_close(ncid)
+
         CALL SYSTEM_CLOCK(millisecs_stop, count_rate, count_max)
 
@@ -105,15 +129,30 @@
                                                   ! Should be 1 or 2 
 
+        INTEGER :: ncretval, ncid          ! NetCDF func return value, file id
+
         INTEGER millisecs_start, millisecs_stop, count_rate, count_max
 
         CALL SYSTEM_CLOCK(millisecs_start, count_rate, count_max)
-        OPEN(IOUNIT_LOAD, file=filename, action='READ', status='OLD', form="unformatted", access="stream")
-        CALL fpio(IOUNIT_LOAD, 'LOAD', cm_index)
-        CLOSE(IOUNIT_LOAD)
+
+PRINT *, "filename: ", filename
+PRINT *, "Opening nc file for reading: ", filename
+        ncretval = nf90_open(filename, NF90_NOWRITE, ncid)
+        call handle_nf90_err(ncretval)
+PRINT *, 'OPENED NC4 FILE FOR READING...'
+
+
+        CALL fpio(ncid, 'LOAD', cm_index)
+
         CALL SYSTEM_CLOCK(millisecs_stop, count_rate, count_max)
         !PRINT *, 'Load walltime secs: ', (millisecs_stop-millisecs_start)/1000.0
     END SUBROUTINE fpmetbinary_load
 
-    SUBROUTINE fpmetbinary_zero(cm_index)
+
+
+
+    SUBROUTINE fpio(ncid, op, cm_index)
+        IMPLICIT NONE
+        INTEGER, INTENT(IN) :: ncid               ! NetCDF file id
+        CHARACTER(LEN=4), INTENT(IN) :: op        ! Operation - DUMP or LOAD
         INTEGER, INTENT(IN) :: cm_index           ! Index of last dimension in
                                                   ! most com_mod variables.
Index: flexpart_code/fpmetbinary_mod.F90
===================================================================
--- flexpart_code/fpmetbinary_mod.F90	(revision 64c820a29518db4158976feda349b1e551dec5c9)
+++ flexpart_code/fpmetbinary_mod.F90	(revision b6b9db0ffbc6a01864e847461061a3bb2f9680bc)
@@ -270,31 +2866,52 @@
                                                   ! Should be 1 or 2 
 
+
+        INTEGER :: temp_integer   ! temporary value
+
+
         ! These are temporary variables, used in the LOAD option, for 
         ! comparing against the current values in FLEXPART of nxmax, nymax, ...
         INTEGER :: temp_nxmax, temp_nymax, temp_nzmax, &
-&                  temp_nuvzmax, temp_nwzmax
-
-        CHARACTER(LEN=12) :: temp_preproc_format_version_str
+&                  temp_nuvzmax, temp_nwzmax, &
+&                  temp_maxspec, temp_numclass,&
+&                  temp_maxnests, temp_nxmaxn, temp_nymaxn, temp_preproc_fmt_str_dim
+
+        CHARACTER(LEN=PREPROC_FMT_STR_DIM) :: temp_preproc_format_version_str
 
         CHARACTER(LEN=128) :: errmesg
 
+        INTEGER, PARAMETER :: DEF_LEVEL = 3
+
         if (op == 'DUMP') THEN
 
 
             ! Write the preprocessing format version string
+            !  NEED TO FILL THIS IN FOR NC4
+
+
+
             WRITE (iounit) PREPROC_FORMAT_VERSION_STR
+
 
             ! Write the compiled max dimensions from par_mod - these are
             ! not meant to be reassigned during a LOAD, but used as "header"
             ! information to provide the structure of arrays
+
+
             WRITE (iounit) nxmax, nymax, nzmax, nuvzmax, nwzmax
 
+
+
+
             ! Scalar values
-            WRITE(iounit) nx, ny, nxmin1, nymin1, nxfield
-            WRITE(iounit) nuvz, nwz, nz, nmixz, nlev_ec
-            WRITE(iounit) dx, dy, xlon0, ylat0, dxconst, dyconst
 
             ! Fixed fields, static in time
+
+
+
             WRITE(iounit) oro, excessoro, lsm, xlanduse, height
+
+
+ 
 
             ! 3d fields
@@ -314,4 +2931,14 @@
             WRITE(iounit) clouds(:,:,:,cm_index)
             WRITE(iounit) cloudsh(:,:,cm_index)
+
+
+
+!            PRINT *, 'SUM(tt(0:nxmax-1, 0:nymax-1, 1:nzmax, cm_index)): ', &
+!&                                        SUM(tt(0:nxmax-1,0:nymax-1,1:nzmax, cm_index))
+
+!            PRINT *, 'SUM(clouds(0:nxmax-1, 0:nymax-1, 1:nzmax, cm_index)): ', &
+!&                                        SUM(clouds(0:nxmax-1,0:nymax-1,1:nzmax, cm_index))
+
+
 
             ! 2d fields
@@ -337,4 +2964,7 @@
             WRITE(iounit) vdep(:,:,:,cm_index)
 
+
+
+
             ! 1d fields
             WRITE(iounit) z0(:)
@@ -346,5 +2976,18 @@
             WRITE(iounit) bknew(:)
 
-            ! Nested, scalar values (for each nest)
+
+
+
+
+!            PRINT *, 'SUM(bknew(1:nzmax)): ', &
+!&                                        SUM(bknew(1:nzmax))
+
+
+
+            ! Getting ready to add in nested code
+
+            ! These are compiled max dimensions from par_mod - these are
+            ! not meant to be reassigned during a LOAD, but used as "header"
+            ! information to provide the structure of arrays
             WRITE(iounit) nxn(:)
             WRITE(iounit) nyn(:)
@@ -354,6 +2997,14 @@
             WRITE(iounit) ylat0n(:)
 
+            ! Nested, scalar values (for each nest)
+
+
             ! Nested fields, static over time
             WRITE(iounit) oron, excessoron, lsmn, xlandusen 
+
+
+!           PRINT *, 'SUM(oron): ', SUM(oron)
+
+
 
             ! 3d nested fields
@@ -370,4 +3021,12 @@
             WRITE(iounit) tthn(:,:,:,cm_index,:)
             WRITE(iounit) qvhn(:,:,:,cm_index,:)
+
+
+
+!            PRINT *, 'SUM(uun): ', SUM(uun(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(qvhn): ', SUM(qvhn(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(cloudsn): ', SUM(cloudsn(:,:,:,cm_index,:))
+
+
 
             ! 2d nested fields
@@ -393,4 +3052,14 @@
             WRITE(iounit) vdepn(:,:,:,cm_index,:)
 
+
+
+!            PRINT *, 'SUM(psn): ', SUM(psn(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(surfstrn): ', SUM(surfstrn(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(vdepn): ', SUM(vdepn(:,:,:,cm_index,:))
+
+
+
+
+
             ! Auxiliary variables for nests
             WRITE(iounit) xresoln(:)
@@ -401,4 +3070,11 @@
             WRITE(iounit) yrn(:)
 
+
+
+!            PRINT *, 'SUM(yresoln): ', SUM(yresoln)
+!            PRINT *, 'SUM(xrn): ', SUM(xrn)
+
+
+
             ! Variables for polar stereographic projection
             WRITE(iounit) xglobal, sglobal, nglobal
@@ -406,4 +3082,14 @@
             WRITE(iounit) southpolemap(:)
             WRITE(iounit) northpolemap(:)
+
+
+
+
+
+!            PRINT *, 'SUM(northpolemap): ', SUM(northpolemap)
+!            PRINT *, 'xglobal: ', xglobal
+!            PRINT *, 'sglobal: ', sglobal
+!            PRINT *, 'nglobal: ', nglobal
+!            PRINT *, 'switchsouthg: ', switchsouthg
 
             ! Variables declared in conv_mod (convection)
@@ -426,4 +3112,16 @@
             WRITE(iounit) nconvlev, nconvtop
 
+
+
+
+!            PRINT *, 'SUM(pconv): ', SUM(pconv)
+!            PRINT *, 'SUM(qconv): ', SUM(qconv)
+!            PRINT *, 'SUM(fmassfrac): ', SUM(fmassfrac)
+!            PRINT *, 'SUM(cbasefluxn): ', SUM(cbasefluxn)
+!            PRINT *, 'tt2conv: ', tt2conv
+!            PRINT *, 'nconvlev: ', nconvlev
+
+
+
         ELSE IF (op == 'LOAD') THEN 
 
@@ -431,7 +3129,7 @@
             ! matches this version
             READ (iounit) temp_preproc_format_version_str
+
             PRINT *, 'Reading preprocessed file format version: ', &
 &                    temp_preproc_format_version_str
-
             IF (TRIM(temp_preproc_format_version_str) == &
 &                                        TRIM(PREPROC_FORMAT_VERSION_STR)) THEN
@@ -446,4 +3144,5 @@
             END IF
 
+
             ! Read the compiled max dimensions that were dumped from par_mod 
             ! when creating the fp file, so that we can compare against
@@ -454,4 +3153,8 @@
 
 
+
+
+
+            ! Get dimensions
             IF ( (temp_nxmax == nxmax) .AND. (temp_nymax == nymax) .AND. &
 &                   (temp_nzmax == nzmax) .AND. &
@@ -461,5 +3164,4 @@
             ELSE
                 PRINT *, 'Incompatible dimensions between fp file and current FLEXPART!'
-                ! PRINT *, ''
                 PRINT *, '                  FP file     Compiled FP'
                 PRINT *, 'nxmax:     ', temp_nxmax, '    ', nxmax 
@@ -467,8 +3169,9 @@
                 PRINT *, 'nzmax:     ', temp_nzmax, '    ', nzmax 
                 PRINT *, 'nuvzmax:     ', temp_nuvzmax, '    ', nuvzmax 
-                PRINT *, 'nwzmax:     ', temp_nwzmax, '    ', nwzmax 
-                ! PRINT *, ''
+                PRINT *, 'nwzmax:     ', temp_nwzmax, '    ', nwzmax
                 STOP
             END IF
+
+
 
 
@@ -478,6 +3181,12 @@
             READ(iounit) dx, dy, xlon0, ylat0, dxconst, dyconst
 
-            ! Fixed fields, static in time
+
+
+
+
+            ! Fixed fields, static in time           
             READ(iounit) oro, excessoro, lsm, xlanduse, height
+
+
 
             ! 3d fields
@@ -497,4 +3206,14 @@
             READ(iounit) clouds(:,:,:,cm_index)
             READ(iounit) cloudsh(:,:,cm_index)
+
+
+!            PRINT *, 'SUM(tt(0:nxmax-1, 0:nymax-1, 1:nzmax, cm_index)): ', &
+!&                                        SUM(tt(0:nxmax-1,0:nymax-1,1:nzmax, cm_index))
+
+
+!            PRINT *, 'SUM(clouds(0:nxmax-1, 0:nymax-1, 1:nzmax, cm_index)): ', &
+!&                                        SUM(clouds(0:nxmax-1,0:nymax-1,1:nzmax, cm_index))
+
+
 
             ! 2d fields
@@ -520,4 +3239,17 @@
             READ(iounit) vdep(:,:,:,cm_index)
 
+
+
+
+
+!            PRINT *, 'SUM(ps(0:nxmax-1, 0:nymax-1, 1, cm_index)): ', &
+!&                                        SUM(ps(0:nxmax-1,0:nymax-1,1, cm_index))
+
+!            PRINT *, 'SUM(wstar(0:nxmax-1, 0:nymax-1, 1, cm_index)): ', &
+!&                                        SUM(wstar(0:nxmax-1,0:nymax-1,1, cm_index))
+
+
+
+
             ! 1d fields
             READ(iounit) z0(:)
@@ -530,4 +3262,12 @@
 
 
+
+!            PRINT *, 'SUM(bknew(1:nzmax)): ', &
+!&                                        SUM(bknew(1:nzmax))
+
+
+
+
+
             ! Nested, scalar values (for each nest)
             READ(iounit) nxn(:)
@@ -539,6 +3279,14 @@
 
 
+
             ! Nested fields, static over time
             READ(iounit) oron, excessoron, lsmn, xlandusen 
+
+
+
+!            PRINT *, 'SUM(oron): ', SUM(oron)
+
+
+
 
             ! 3d nested fields
@@ -555,4 +3303,11 @@
             READ(iounit) tthn(:,:,:,cm_index,:)
             READ(iounit) qvhn(:,:,:,cm_index,:)
+
+!            PRINT *, 'SUM(uun): ', SUM(uun(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(qvhn): ', SUM(qvhn(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(cloudsn): ', SUM(cloudsn(:,:,:,cm_index,:))
+
+
+
 
             ! 2d nested fields
@@ -578,4 +3333,10 @@
             READ(iounit) vdepn(:,:,:,cm_index,:)
 
+!            PRINT *, 'SUM(psn): ', SUM(psn(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(surfstrn): ', SUM(surfstrn(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(vdepn): ', SUM(vdepn(:,:,:,cm_index,:))
+
+
+
             ! Auxiliary variables for nests
             READ(iounit) xresoln(:)
@@ -584,5 +3345,10 @@
             READ(iounit) yln(:)
             READ(iounit) xrn(:)
-            READ(iounit) yrn(:)
+
+
+!            PRINT *, 'SUM(yresoln): ', SUM(yresoln)
+!            PRINT *, 'SUM(xrn): ', SUM(xrn)
+
+
 
             ! Variables for polar stereographic projection
@@ -591,4 +3357,14 @@
             READ(iounit) southpolemap(:)
             READ(iounit) northpolemap(:)
+
+
+!            PRINT *, 'SUM(northpolemap): ', SUM(northpolemap)
+!            PRINT *, 'xglobal: ', xglobal
+!            PRINT *, 'sglobal: ', sglobal
+!            PRINT *, 'nglobal: ', nglobal
+!            PRINT *, 'switchsouthg: ', switchsouthg
+
+
+
 
             ! Variables declared in conv_mod (convection)
@@ -611,55 +3387,79 @@
             READ(iounit) nconvlev, nconvtop
 
+
+
+
+
+!            PRINT *, 'SUM(pconv): ', SUM(pconv)
+!            PRINT *, 'SUM(qconv): ', SUM(qconv)
+!            PRINT *, 'SUM(fmassfrac): ', SUM(fmassfrac)
+!            PRINT *, 'SUM(cbasefluxn): ', SUM(cbasefluxn)
+!            PRINT *, 'tt2conv: ', tt2conv
+!            PRINT *, 'nconvlev: ', nconvlev
+
+
+
         ELSE
-            STOP 'fpio(): Illegal operation' 
+            STOP 'fpio_rawbin(): Illegal operation' 
             
         ENDIF
-    END SUBROUTINE fpio
-
-    SUBROUTINE fpmetbinary_filetext(filename, cm_index)
-
-        ! This is a utility subroutine meant to be used for testing purposes.
-        ! It facilitates the text output of variables read in from the 
-        ! specified .fp file.  This routine will easily cause the program
-        ! to crash due memory allocation issues, particularly when you are
-        ! trying to text print 3d arrays in a single formatted statetment.
-        
-        CHARACTER(LEN=*), INTENT(IN) :: filename
-        INTEGER, INTENT(IN) :: cm_index           ! Index of last dimension in
-                                                  ! most com_mod variables.
-                                                  ! Should be 1 or 2 
-
-        !OPEN(IOUNIT_TEXTOUT, file=filename, action='WRITE', status='REPLACE', &
-        !    form="formatted", access="stream")
-        OPEN(IOUNIT_TEXTOUT, file=filename, action='WRITE', &
-             form="formatted", access="APPEND")
-
-        WRITE(IOUNIT_TEXTOUT, *) 'oro: ', oro
-        WRITE(IOUNIT_TEXTOUT, *) 'excessoro: ', excessoro
-        WRITE(IOUNIT_TEXTOUT, *) 'lsm: ', lsm
-        WRITE(IOUNIT_TEXTOUT, *) 'xlanduse: ', xlanduse
-        WRITE(IOUNIT_TEXTOUT, *) 'height: ', height
-
-        WRITE(IOUNIT_TEXTOUT, *) 'uu: ', uu(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'vv: ', vv(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'uupol: ', uupol(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'vvpol: ', vvpol(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'ww: ', ww(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'tt: ', tt(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'qv: ', qv(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'pv: ', pv(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'rho: ', rho(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'drhodz: ', drhodz(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'tth: ', tth(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'qvh: ', qvh(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'pplev: ', pplev(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'clouds: ', clouds(:,:,:,cm_index)
-        WRITE(IOUNIT_TEXTOUT, *) 'cloudsh: ', cloudsh(:,:,cm_index)
-
-
-
-
-        CLOSE(IOUNIT_TEXTOUT)
-    END SUBROUTINE fpmetbinary_filetext
+    END SUBROUTINE fpio_rawbin
+
+
+
+
+    subroutine handle_nf90_err(status)
+
+        ! Custom routine for checking NF90 error status
+        ! and aborting if necessary
+        use netcdf
+        implicit none
+        integer, intent (in) :: status
+
+        if (status /= nf90_noerr) then
+            print *, trim(nf90_strerror(status))
+            stop "Stopped..."
+        endif
+    end subroutine handle_nf90_err
+
+
+    INTEGER FUNCTION logical2integer(logical_value)
+        IMPLICIT NONE
+
+        ! Auxiliary function to convert logical values to
+        ! integers.  THIS DOES NO TYPE CHECKING!!!
+
+
+        LOGICAL, INTENT(IN) :: logical_value
+
+        IF (logical_value .EQV. .TRUE.) THEN
+            logical2integer = 1
+        ELSE
+            logical2integer = 0
+        ENDIF
+
+        RETURN
+
+    END FUNCTION logical2integer
+
+
+    LOGICAL FUNCTION integer2logical(integer_value)
+        IMPLICIT NONE
+
+        ! Auxiliary function to convert integer values to
+        ! logical.  THIS DOES NO TYPE CHECKING!!!
+
+
+        INTEGER, INTENT(IN) :: integer_value
+
+        IF (integer_value .EQ. 0) THEN
+            integer2logical = .FALSE.
+        ELSE
+            integer2logical = .TRUE.
+        ENDIF
+
+        RETURN
+
+    END FUNCTION integer2logical
 
 
